import { AdapterAbstract } from './Abstract';
import * as Boom from 'boom';
export declare abstract class LoggerSegment {
    abstract close(): void;
}
export interface IAddContextProps {
    user?: {
        userId: string;
        workspaceId?: string;
        permissions?: string[];
    };
    method?: 'GET' | 'POST' | 'PUT' | 'DELETE' | 'WORKER';
    path?: string;
    transactionName?: string;
    serviceName?: string;
    serviceType?: string;
}
export declare abstract class AdapterLogger<I extends LoggerSegment = LoggerSegment> extends AdapterAbstract {
    abstract initSDK(): this;
    abstract initRequest(context: IAddContextProps, keys?: Map<string, string>): this;
    abstract flush(): Promise<void>;
    abstract log(message: string, namespace: string): this;
    abstract reportException(e: Boom, namespace: string): this;
    abstract createSegment(name: string): I;
}
